diff --git a/vhdlparser/VhdlParser.h b/vhdlparser/VhdlParser.h
index bd02af3..f942612 100644
--- a/vhdlparser/VhdlParser.h
+++ b/vhdlparser/VhdlParser.h
@@ -8867,32 +8839,55 @@ void parseInline();
     return false;
   }
 
+ inline bool jj_3R_228()
+ {
+    if (jj_done) return true;
+    if (jj_3R_94()) return true;
+    return false;
+  }
 
-public: 
-  TokenManager *token_source;
-  CharStream   *jj_input_stream;
+ inline bool jj_3R_106()
+ {
+    if (jj_done) return true;
+    Token * xsp;
+    xsp = jj_scanpos;
+    if (jj_3R_228()) {
+    jj_scanpos = xsp;
+    if (jj_3R_229()) {
+    jj_scanpos = xsp;
+    if (jj_3R_230()) {
+    jj_scanpos = xsp;
+    if (jj_3R_231()) {
+    jj_scanpos = xsp;
+    if (jj_3R_232()) return true;
+    }
+    }
+    }
+    }
+    return false;
+  }
+
+  public: TokenManager *token_source;
+  public: CharStream *jj_input_stream;
   /** Current token. */
-  Token        *token;
+  public: Token *token;
   /** Next token. */
-  Token        *jj_nt;
-private: 
-  int           jj_ntk;
-  JJCalls       jj_2_rtns[116];
-  bool          jj_rescan;
-  int           jj_gc;
-  Token        *jj_scanpos, *jj_lastpos;
-  int           jj_la;
+  public: Token *jj_nt;
+  private: int jj_ntk;
+  private: JJCalls jj_2_rtns[116];
+  private: bool jj_rescan;
+  private: int jj_gc;
+  private: Token *jj_scanpos, *jj_lastpos;
+  private: int jj_la;
   /** Whether we are looking ahead. */
-  bool          jj_lookingAhead;
-  bool          jj_semLA;
-  int           jj_gen;
-  int           jj_la1[294];
-  ErrorHandler *errorHandler;
-  bool          errorHandlerCreated;
-protected: 
-  bool          hasError;
-public: 
-  void setErrorHandler(ErrorHandler *eh) {
+  private: bool jj_lookingAhead;
+  private: bool jj_semLA;
+  private: int jj_gen;
+  private: int jj_la1[294];
+  private: ErrorHandler *errorHandler;
+  private: bool errorHandlerCreated;
+  protected: bool hasError;
+  public: void setErrorHandler(ErrorHandler *eh) {
     if (errorHandlerCreated) delete errorHandler;
     errorHandler = eh;
     errorHandlerCreated = false;
@@ -8901,12 +8896,10 @@ public:
  public: 
 
  VhdlParser(TokenManager *tm);
-  virtual ~VhdlParser();
+   public: virtual ~VhdlParser();
 
 void ReInit(TokenManager *tm);
 
-void clear();
-
 Token * jj_consume_token(int kind);
 
 bool  jj_scan_token(int kind);
@@ -8916,25 +8909,20 @@ Token * getNextToken();
 Token * getToken(int index);
 
 int jj_ntk_f();
-private:
-  int jj_kind;
+ private: int jj_kind;
   int **jj_expentries;
   int *jj_expentry;
 
 void jj_add_error_token(int kind, int pos);
-protected:
-  /** Generate ParseException. */
 
-  virtual void  parseError();
-private:
-  int  trace_indent;
-  bool trace_enabled;
-
-public:
+protected: virtual void  parseError();
+  private: int trace_indent;
+  private: bool trace_enabled;
+  /** Enable tracing. */
 
-  void enable_tracing();
+public: void enable_tracing();
 
-  void disable_tracing();
+public: void disable_tracing();
 
 void jj_rescan_token();
 
@@ -8946,13 +8934,13 @@ static Entry* tempEntry;
 static Entry*  lastEntity  ;
 static Entry*  lastCompound  ;
 static Entry*  current;
-static QCString compSpec;
-static QCString currName;
+static VhdlString compSpec;
+static VhdlString currName;
 static int levelCounter;
-static QCString confName;
-static QCString genLabels;
-static QCString lab;
-static QCString forL;
+static VhdlString confName;
+static VhdlString genLabels;
+static VhdlString lab;
+static VhdlString forL;
 static int param_sec ;
 static int parse_sec;
 static int currP;
@@ -8975,17 +8963,15 @@ static void handleFlowComment(const char*);
 static void initEntry(Entry *e);
 static  void newEntry();
 static  bool isFuncProcProced();
-static void pushLabel(QCString &,QCString&);
-static  QCString popLabel(QCString & q);
-static  bool addLibUseClause(const QCString &type);
+static void pushLabel(VhdlString &,VhdlString&);
+static  VhdlString popLabel(VhdlString & q);
+static  bool addLibUseClause(const VhdlString &type);
 static  void mapLibPackage( Entry* root);
 static void createFlow();
 static void error_skipto(int kind);
-static void oneLineComment(QCString qcs);
-static void setMultCommentLine();
+static void oneLineComment(VhdlString qcs);
+static void setMultCommentLine();private: bool jj_done;
 
-private:
-  bool jj_done;
 };
 }
 }
diff --git a/vhdlparser/VhdlParserIF.cpp b/vhdlparser/VhdlParserIF.cpp
index f9f689b..bcce0cc 100644
--- a/vhdlparser/VhdlParserIF.cpp
+++ b/vhdlparser/VhdlParserIF.cpp
@@ -11,7 +12,21 @@ static VhdlParser * myParser=0;
 
 void  VhdlParserIF::parseVhdlfile(const char* inputBuffer,bool inLine)
 {
+//  en_US.UTF-8 must be set for conversion functions like (mbstowcs wcstombs ..char --> wchar_t see )
+  setlocale(LC_ALL,"en_US.UTF-8");
   JAVACC_STRING_TYPE s = inputBuffer;
+  int fsize=s.length();
+
+  // remove idle \0 chars
+
+  for(int p=0;p<fsize;p++)
+  {
+    if(s[p]==L'\0'){
+      s[p]=L' ';
+       }
+  }
+ // fprintf(stderr,"\n found %d zeros \n",count);
+
   CharStream *stream = new CharStream(s.c_str(), (int)s.size(), 1, 1);
   VhdlParserTokenManager *tokenManager = new VhdlParserTokenManager(stream);
   myParser=new VhdlParser(tokenManager);
diff --git a/vhdlparser/VhdlParserTokenManager.cc b/vhdlparser/VhdlParserTokenManager.cc
index 07364a4..d123d2c 100644
--- a/vhdlparser/VhdlParserTokenManager.cc
+++ b/vhdlparser/VhdlParserTokenManager.cc
@@ -1,6 +1,5 @@
 /* VhdlParserTokenManager.cc */
-#include "VhdlParserTokenManager.h"
-#include "TokenMgrError.h"
+#include "./VhdlParserTokenManager.h"
 namespace vhdl {
 namespace parser {
 static const unsigned long long jjbitVec0[] = {
@@ -3305,6 +3304,8 @@ bool VhdlParserTokenManager::jjCanMove_1(int hiByte, int i1, int i2, unsigned lo
       case 0:
          return ((jjbitVec3[i2] & l2) != 0L);
       default :
+         if ((jjbitVec0[i1] & l1) != 0L)
+            return true;
          return false;
    }
 }
@@ -3314,10 +3315,10 @@ bool VhdlParserTokenManager::jjCanMove_1(int hiByte, int i1, int i2, unsigned lo
 Token * VhdlParserTokenManager::jjFillToken(){
    Token *t;
    JAVACC_STRING_TYPE curTokenImage;
-   int beginLine   = -1;
-   int endLine     = -1;
-   int beginColumn = -1;
-   int endColumn   = -1;
+   int beginLine;
+   int endLine;
+   int beginColumn;
+   int endColumn;
    JAVACC_STRING_TYPE im = jjstrLiteralImages[jjmatchedKind];
    curTokenImage = (im.length() == 0) ? input_stream->GetImage() : im;
    if (input_stream->getTrackLineColumn()) {
@@ -3326,9 +3327,7 @@ Token * VhdlParserTokenManager::jjFillToken(){
      endLine = input_stream->getEndLine();
      endColumn = input_stream->getEndColumn();
    }
-   t = Token::newToken(jjmatchedKind);
-   t->kind = jjmatchedKind;
-   t->image = curTokenImage;
+   t = Token::newToken(jjmatchedKind, curTokenImage);
    t->specialToken = NULL;
    t->next = NULL;
 
@@ -3415,14 +3414,14 @@ void  VhdlParserTokenManager::SkipLexicalActions(Token *matchedToken){
       case 6 : {
          image.append(input_stream->GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
     {
-    QCString doc(image.data());
+    VhdlString doc(image);
     int count=doc.contains("--!");
     ::vhdl::parser::VhdlParser::setMultCommentLine();
     ::vhdl::parser::VhdlParser::lineCount(image.data());
     if (count == 1)
       ::vhdl::parser::VhdlParser::oneLineComment(doc);
     else
-      ::vhdl::parser::VhdlParser::handleCommentBlock(image.data(),FALSE); ;
+      ::vhdl::parser::VhdlParser::handleCommentBlock(doc.data(),FALSE); ;
     }
          break;
        }
@@ -3439,7 +3438,7 @@ void  VhdlParserTokenManager::SkipLexicalActions(Token *matchedToken){
       case 9 : {
          image.append(input_stream->GetSuffix(jjimageLen + (lengthOfMatch = jjmatchedPos + 1)));
    {
-     QCString q(image.data());
+     VhdlString q(image);
      q.stripPrefix("/*!");
      q.resize(q.length()-2);
      ::vhdl::parser::VhdlParser::handleCommentBlock(q.data(),TRUE);image.clear();
@@ -3586,7 +3585,7 @@ void  VhdlParserTokenManager::TokenLexicalActions(Token *matchedToken){
 }
   /** Reinitialise parser. */
   void VhdlParserTokenManager::ReInit(JAVACC_CHARSTREAM *stream, int lexState, VhdlParser *parserArg) {
-    clear();
+    if (input_stream) delete input_stream;
     jjmatchedPos = jjnewStateCnt = 0;
     curLexState = lexState;
     input_stream = stream;
@@ -3607,17 +3606,10 @@ void  VhdlParserTokenManager::TokenLexicalActions(Token *matchedToken){
 
   /** Switch to specified lex state. */
   void VhdlParserTokenManager::SwitchTo(int lexState) {
-    if (lexState >= 1 || lexState < 0) {
-      JAVACC_STRING_TYPE message;
-#ifdef WIDE_CHAR
-      message += L"Error: Ignoring invalid lexical state : ";
-      message += lexState; message += L". State unchanged.";
-#else
-      message += "Error: Ignoring invalid lexical state : ";
-      message += lexState; message += ". State unchanged.";
-#endif
-      throw new TokenMgrError(message, INVALID_LEXICAL_STATE);
-    } else
+    if (lexState >= 1 || lexState < 0)
+      assert(false);
+      //throw 1;//new TokenMgrError("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.", TokenMgrError.INVALID_LEXICAL_STATE);
+    else
       curLexState = lexState;
   }
 
@@ -3625,20 +3617,12 @@ void  VhdlParserTokenManager::TokenLexicalActions(Token *matchedToken){
   VhdlParserTokenManager::VhdlParserTokenManager (JAVACC_CHARSTREAM *stream, int lexState, VhdlParser *parserArg)
   {
     input_stream = NULL;
-    errorHandlerCreated = false;
     ReInit(stream, lexState, parserArg);
   }
 
   // Destructor
   VhdlParserTokenManager::~VhdlParserTokenManager () {
-    clear();
-  }
-
-  // clear
-  void VhdlParserTokenManager::clear() {
-    //Since input_stream was generated outside of TokenManager
-    //TokenManager should not take care of deleting it
-    //if (input_stream) delete input_stream;
+    if (input_stream) delete input_stream;
     if (errorHandlerCreated) delete errorHandler;
   }
 
diff --git a/vhdlparser/VhdlParserTokenManager.h b/vhdlparser/VhdlParserTokenManager.h
index d624373..7f0204c 100644
--- a/vhdlparser/VhdlParserTokenManager.h
+++ b/vhdlparser/VhdlParserTokenManager.h
@@ -1,6 +1,5 @@
 #ifndef VHDLPARSERTOKENMANAGER_H
 #define VHDLPARSERTOKENMANAGER_H
-#include "stdio.h"
 #include "JavaCC.h"
 #include "CharStream.h"
 #include "Token.h"
@@ -117,7 +116,6 @@ void  TokenLexicalActions(Token *matchedToken);
   public: virtual ~VhdlParserTokenManager();
   void ReInit(JAVACC_CHARSTREAM *stream, int lexState = 0, VhdlParser *parserArg = NULL);
   void SwitchTo(int lexState);
-  void clear();
   const JAVACC_SIMPLE_STRING jjKindsForBitVector(int i, unsigned long long vec);
   const JAVACC_SIMPLE_STRING jjKindsForStateVector(int lexState, int vec[], int start, int end);
     JAVACC_CHARSTREAM  *input_stream;
@@ -130,9 +128,7 @@ void  TokenLexicalActions(Token *matchedToken);
     JAVACC_CHAR_TYPE curChar;
     TokenManagerErrorHandler *errorHandler;
     bool errorHandlerCreated;
-
-public: 
-  void setErrorHandler(TokenManagerErrorHandler *eh) {
+    public: void setErrorHandler(TokenManagerErrorHandler *eh) {
       if (errorHandlerCreated && errorHandler != NULL) delete errorHandler;
       errorHandler = eh;
       errorHandlerCreated = false;
